﻿using System;
using System.IO;
using System.Net.Sockets;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;
using System.Net;

namespace locationserver
{
    public class ProtocolChoice
    {
        public void WholeLeaderBoardUpdate(string[] splitString, StreamWriter sw, StreamReader sr, ref LeaderboardItem[] leaderboard)
        {
            leaderboard[0].NAME = splitString[0]; leaderboard[0].SCORE = int.Parse(splitString[1]);
            leaderboard[1].NAME = splitString[2]; leaderboard[1].SCORE = int.Parse(splitString[3]);
            leaderboard[2].NAME = splitString[4]; leaderboard[2].SCORE = int.Parse(splitString[5]);
            leaderboard[3].NAME = splitString[6]; leaderboard[3].SCORE = int.Parse(splitString[7]);
            leaderboard[4].NAME = splitString[8]; leaderboard[4].SCORE = int.Parse(splitString[9]);
        }

        public void SingleUpdate(string[] splitString, StreamWriter sw, StreamReader sr, ref LeaderboardItem[] leaderboard)
        {
            for (int i = 0; i < leaderboard.Length; i++)
            {
                if (int.Parse(splitString[1]) > leaderboard[i].SCORE)
                {
                    for (int j = leaderboard.Length - 1; j > i; j--)
                    {
                        leaderboard[j].NAME = leaderboard[j - 1].NAME;
                        leaderboard[j].SCORE = leaderboard[j - 1].SCORE;
                    }
                    leaderboard[i].NAME = splitString[0];
                    leaderboard[i].SCORE = int.Parse(splitString[1]);
                }
            }
        }

        public void SendWholeLeaderboard(StreamWriter sw, ref LeaderboardItem[] leaderboard)
        {
            sw.WriteLine(leaderboard[0].NAME + " " + leaderboard[0].SCORE + " " +
                leaderboard[1].NAME + " " + leaderboard[1].SCORE + " " +
                leaderboard[2].NAME + " " + leaderboard[2].SCORE + " " +
                leaderboard[3].NAME + " " + leaderboard[3].SCORE + " " +
                leaderboard[4].NAME + " " + leaderboard[4].SCORE);
        }
    }
}
